using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

using System.CodeDom;

namespace CollectionBuilder
{

	/// <summary>
	/// Summary description for ScopeControl.
	/// </summary>
	public class ScopeControl : System.Windows.Forms.UserControl
	{

		#region Housekeeping 

		private System.Windows.Forms.RadioButton rdoPublic;
		private System.Windows.Forms.RadioButton rdoInternal;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ScopeControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.rdoPublic = new System.Windows.Forms.RadioButton();
			this.rdoInternal = new System.Windows.Forms.RadioButton();
			this.SuspendLayout();
			// 
			// rdoPublic
			// 
			this.rdoPublic.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.rdoPublic.Checked = true;
			this.rdoPublic.Location = new System.Drawing.Point(4, 4);
			this.rdoPublic.Name = "rdoPublic";
			this.rdoPublic.Size = new System.Drawing.Size(232, 24);
			this.rdoPublic.TabIndex = 0;
			this.rdoPublic.TabStop = true;
			this.rdoPublic.Text = "Public Accessibilty";
			// 
			// rdoInternal
			// 
			this.rdoInternal.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.rdoInternal.Location = new System.Drawing.Point(4, 28);
			this.rdoInternal.Name = "rdoInternal";
			this.rdoInternal.Size = new System.Drawing.Size(232, 24);
			this.rdoInternal.TabIndex = 1;
			this.rdoInternal.Text = "Internal-Only accessibility";
			// 
			// ScopeControl
			// 
			this.Controls.Add(this.rdoInternal);
			this.Controls.Add(this.rdoPublic);
			this.Name = "ScopeControl";
			this.Size = new System.Drawing.Size(240, 52);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		#region Public properties 

		[DefaultValue( MemberAttributes.Public )]
		public System.CodeDom.MemberAttributes Scope
		{

			get 
			{

				if( rdoPublic.Checked )
					return MemberAttributes.Public;
				else if( rdoInternal.Checked )
					return MemberAttributes.Assembly;
				else
					throw new Exception( "Unrecognized member scope" );

			}

			set 
			{

				rdoPublic.Checked = false;
				rdoInternal.Checked = false;

				if( value == MemberAttributes.Public )
					rdoPublic.Checked = true;
				else if( value == MemberAttributes.Assembly )
					rdoInternal.Checked = true;
				else
					throw new Exception( "Unrecognized member scope" );

			}

		}

		#endregion 

	}

}
