using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GooglePlugin
{

	/// <summary>
	/// Allows the user to enter search keywords manually
	/// </summary>
	public class EnterSearchText : System.Windows.Forms.Form
	{

		#region 

		private System.Windows.Forms.Label lblDescription;
		private System.Windows.Forms.Button Search;
		private System.Windows.Forms.Button Cancel;
		private System.Windows.Forms.ComboBox Keywords;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public EnterSearchText()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(EnterSearchText));
			this.lblDescription = new System.Windows.Forms.Label();
			this.Search = new System.Windows.Forms.Button();
			this.Cancel = new System.Windows.Forms.Button();
			this.Keywords = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// lblDescription
			// 
			this.lblDescription.Location = new System.Drawing.Point(8, 8);
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.Size = new System.Drawing.Size(396, 44);
			this.lblDescription.TabIndex = 0;
			this.lblDescription.Text = "You either have not selected any text in the current document window, or you do n" +
				"ot have a document open.  Please enter the keywords you wish to search for in th" +
				"e field below.";
			// 
			// Search
			// 
			this.Search.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.Search.Image = ((System.Drawing.Image)(resources.GetObject("Search.Image")));
			this.Search.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.Search.Location = new System.Drawing.Point(240, 84);
			this.Search.Name = "Search";
			this.Search.TabIndex = 2;
			this.Search.Text = "&Search";
			this.Search.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.Search.Click += new System.EventHandler(this.Search_Click);
			// 
			// Cancel
			// 
			this.Cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.Cancel.Location = new System.Drawing.Point(328, 84);
			this.Cancel.Name = "Cancel";
			this.Cancel.TabIndex = 3;
			this.Cancel.Text = "&Cancel";
			// 
			// Keywords
			// 
			this.Keywords.Location = new System.Drawing.Point(4, 56);
			this.Keywords.Name = "Keywords";
			this.Keywords.Size = new System.Drawing.Size(400, 21);
			this.Keywords.TabIndex = 1;
			// 
			// EnterSearchText
			// 
			this.AcceptButton = this.Search;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.Cancel;
			this.ClientSize = new System.Drawing.Size(410, 116);
			this.ControlBox = false;
			this.Controls.Add(this.Keywords);
			this.Controls.Add(this.Cancel);
			this.Controls.Add(this.Search);
			this.Controls.Add(this.lblDescription);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "EnterSearchText";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Search Google - Enter Keywords";
			this.Load += new System.EventHandler(this.EnterSearchText_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		public static string GetKeywords( ArrayList mruList )
		{

			EnterSearchText dlg = new EnterSearchText();
			foreach( string item in mruList )
				dlg.Keywords.Items.Add( item );

			DialogResult result = dlg.ShowDialog();
			if( result == DialogResult.OK )
				return dlg.Keywords.Text.Trim();
			else
				return String.Empty;

		}

		private void EnterSearchText_Load(object sender, System.EventArgs e)
		{
			Keywords.Focus();
		}

		private void Search_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

	}

}
