using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace RSSReaderPlugin.Controls
{

	/// <summary>
	/// Provides a DropdownList specific to TimeSpan values
	/// </summary>
	public class TimespanDropdown : System.Windows.Forms.UserControl
	{

		#region 

		private System.Windows.Forms.ComboBox combo;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TimespanDropdown()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.combo = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// combo
			// 
			this.combo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.combo.Items.AddRange(new object[] {
													   "15 minutes",
													   "30 minutes",
													   "1 hour",
													   "2 hours",
													   "4 hours",
													   "8 hours",
													   "24 hours",
													   "1 week",
													   "2 weeks",
													   "30 days",
													   "60 days",
													   "90 days",
													   "120 days",
													   "180 days",
													   "365 days"});
			this.combo.Location = new System.Drawing.Point(0, 0);
			this.combo.Name = "combo";
			this.combo.Size = new System.Drawing.Size(121, 21);
			this.combo.TabIndex = 0;
			// 
			// TimespanDropdown
			// 
			this.Controls.Add(this.combo);
			this.Name = "TimespanDropdown";
			this.Size = new System.Drawing.Size(121, 21);
			this.Load += new System.EventHandler(this.TimespanDropdown_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		#region TimeSpanList array 

		private TimeSpan[] timeSpanList = {
											  TimeSpan.FromMinutes( 15 ),
											  TimeSpan.FromMinutes( 30 ),
											  TimeSpan.FromHours( 1 ),
											  TimeSpan.FromHours( 2 ),
											  TimeSpan.FromHours( 4 ),
											  TimeSpan.FromHours( 8 ),
											  TimeSpan.FromDays( 1 ),
											  TimeSpan.FromDays( 7 ),
											  TimeSpan.FromDays( 14 ),
											  TimeSpan.FromDays( 30 ),
											  TimeSpan.FromDays( 60 ),
											  TimeSpan.FromDays( 90 ),
											  TimeSpan.FromDays( 120 ),
											  TimeSpan.FromDays( 180 ),
											  TimeSpan.FromDays( 365 )
										  };
		
		#endregion 

		private void TimespanDropdown_Load(object sender, System.EventArgs e)
		{
			combo.SelectedIndex = 0;
		}

		public TimeSpan SelectedValue
		{

			get
			{

				if( combo.SelectedIndex == -1 )
					return TimeSpan.Zero;
				else
					return timeSpanList[ combo.SelectedIndex ];

			}

			set
			{

				for( int i = 0; i < timeSpanList.Length; i++ )
				{

					if( timeSpanList[i].Equals( value ) )
					{
						combo.SelectedIndex = i;
						return;
					}

				}

				combo.SelectedIndex = 0;

			}

		}

	}

}
