using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

using RSSReader.OPML;
using RSSReader.RSS;
using RSSReader.Controls;

namespace RSSReader
{
	/// <summary>
	/// Summary description for ImportOPML.
	/// </summary>
	public class ImportOPML : System.Windows.Forms.Form
	{

		#region 

		private RSSReader.Label3D lblDescription;
		private System.Windows.Forms.Button Cancel;
		private System.Windows.Forms.Button OK;
		private System.Windows.Forms.ImageList imlTree;
		private System.Windows.Forms.TreeView tvwSubscriptions;
		private RSSReader.GradientLabel gradientLabel1;
		private RSSReader.GradientLabel gradientLabel2;
		private System.Windows.Forms.PropertyGrid propertyGrid1;
		private System.Windows.Forms.Button None;
		private System.Windows.Forms.Button All;
		private RSSReader.Controls.FeedListView feedListView1;
		private RSSReader.GradientLabel gradientLabel3;
		private System.ComponentModel.IContainer components;

		public ImportOPML()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ImportOPML));
			this.lblDescription = new RSSReader.Label3D();
			this.Cancel = new System.Windows.Forms.Button();
			this.OK = new System.Windows.Forms.Button();
			this.imlTree = new System.Windows.Forms.ImageList(this.components);
			this.tvwSubscriptions = new System.Windows.Forms.TreeView();
			this.gradientLabel1 = new RSSReader.GradientLabel();
			this.gradientLabel2 = new RSSReader.GradientLabel();
			this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
			this.None = new System.Windows.Forms.Button();
			this.All = new System.Windows.Forms.Button();
			this.feedListView1 = new RSSReader.Controls.FeedListView();
			this.gradientLabel3 = new RSSReader.GradientLabel();
			this.SuspendLayout();
			// 
			// lblDescription
			// 
			this.lblDescription.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblDescription.BackColor = System.Drawing.Color.Transparent;
			this.lblDescription.Location = new System.Drawing.Point(12, 6);
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.ShadowColor = System.Drawing.Color.White;
			this.lblDescription.Size = new System.Drawing.Size(710, 34);
			this.lblDescription.TabIndex = 10;
			this.lblDescription.Text = "The following subscriptions were found in the import file and were not found in y" +
				"our current list of subscribed feeds.  Please check the feeds and categories you" +
				" would like to import, and click \"OK\".";
			// 
			// Cancel
			// 
			this.Cancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.Cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.Cancel.Location = new System.Drawing.Point(646, 508);
			this.Cancel.Name = "Cancel";
			this.Cancel.TabIndex = 13;
			this.Cancel.Text = "&Cancel";
			// 
			// OK
			// 
			this.OK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.OK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.OK.Location = new System.Drawing.Point(558, 508);
			this.OK.Name = "OK";
			this.OK.TabIndex = 12;
			this.OK.Text = "&OK";
			this.OK.Click += new System.EventHandler(this.OK_Click);
			// 
			// imlTree
			// 
			this.imlTree.ImageSize = new System.Drawing.Size(16, 16);
			this.imlTree.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlTree.ImageStream")));
			this.imlTree.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// tvwSubscriptions
			// 
			this.tvwSubscriptions.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.tvwSubscriptions.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.tvwSubscriptions.CheckBoxes = true;
			this.tvwSubscriptions.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tvwSubscriptions.HideSelection = false;
			this.tvwSubscriptions.ImageList = this.imlTree;
			this.tvwSubscriptions.Indent = 19;
			this.tvwSubscriptions.Location = new System.Drawing.Point(12, 60);
			this.tvwSubscriptions.Name = "tvwSubscriptions";
			this.tvwSubscriptions.ShowRootLines = false;
			this.tvwSubscriptions.Size = new System.Drawing.Size(266, 440);
			this.tvwSubscriptions.TabIndex = 14;
			this.tvwSubscriptions.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.tvwSubscriptions_AfterCheck);
			this.tvwSubscriptions.DoubleClick += new System.EventHandler(this.tvwSubscriptions_DoubleClick);
			this.tvwSubscriptions.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvwSubscriptions_AfterSelect);
			// 
			// gradientLabel1
			// 
			this.gradientLabel1.BackColor = System.Drawing.Color.Black;
			this.gradientLabel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gradientLabel1.EndColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(51)), ((System.Byte)(153)));
			this.gradientLabel1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.gradientLabel1.ForeColor = System.Drawing.Color.White;
			this.gradientLabel1.Location = new System.Drawing.Point(12, 40);
			this.gradientLabel1.Name = "gradientLabel1";
			this.gradientLabel1.Size = new System.Drawing.Size(266, 20);
			this.gradientLabel1.StartColor = System.Drawing.Color.FromArgb(((System.Byte)(102)), ((System.Byte)(153)), ((System.Byte)(204)));
			this.gradientLabel1.TabIndex = 15;
			this.gradientLabel1.Text = "Available Feeds (DblClick to Preview)";
			// 
			// gradientLabel2
			// 
			this.gradientLabel2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gradientLabel2.BackColor = System.Drawing.Color.Black;
			this.gradientLabel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gradientLabel2.EndColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(51)), ((System.Byte)(153)));
			this.gradientLabel2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.gradientLabel2.ForeColor = System.Drawing.Color.White;
			this.gradientLabel2.Location = new System.Drawing.Point(286, 40);
			this.gradientLabel2.Name = "gradientLabel2";
			this.gradientLabel2.Size = new System.Drawing.Size(436, 20);
			this.gradientLabel2.StartColor = System.Drawing.Color.FromArgb(((System.Byte)(102)), ((System.Byte)(153)), ((System.Byte)(204)));
			this.gradientLabel2.TabIndex = 17;
			this.gradientLabel2.Text = "Feed Properties";
			// 
			// propertyGrid1
			// 
			this.propertyGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.propertyGrid1.CommandsVisibleIfAvailable = true;
			this.propertyGrid1.LargeButtons = false;
			this.propertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
			this.propertyGrid1.Location = new System.Drawing.Point(286, 60);
			this.propertyGrid1.Name = "propertyGrid1";
			this.propertyGrid1.PropertySort = System.Windows.Forms.PropertySort.Alphabetical;
			this.propertyGrid1.Size = new System.Drawing.Size(436, 156);
			this.propertyGrid1.TabIndex = 16;
			this.propertyGrid1.Text = "propertyGrid1";
			this.propertyGrid1.ToolbarVisible = false;
			this.propertyGrid1.ViewBackColor = System.Drawing.SystemColors.Window;
			this.propertyGrid1.ViewForeColor = System.Drawing.SystemColors.WindowText;
			// 
			// None
			// 
			this.None.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.None.Location = new System.Drawing.Point(94, 508);
			this.None.Name = "None";
			this.None.TabIndex = 18;
			this.None.Text = "&None";
			this.None.Click += new System.EventHandler(this.None_Click);
			// 
			// All
			// 
			this.All.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.All.Location = new System.Drawing.Point(12, 508);
			this.All.Name = "All";
			this.All.TabIndex = 19;
			this.All.Text = "&All";
			this.All.Click += new System.EventHandler(this.All_Click);
			// 
			// feedListView1
			// 
			this.feedListView1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.feedListView1.Location = new System.Drawing.Point(286, 238);
			this.feedListView1.Name = "feedListView1";
			this.feedListView1.Size = new System.Drawing.Size(434, 260);
			this.feedListView1.Subscription = null;
			this.feedListView1.TabIndex = 21;
			// 
			// gradientLabel3
			// 
			this.gradientLabel3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gradientLabel3.BackColor = System.Drawing.Color.Black;
			this.gradientLabel3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gradientLabel3.EndColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(51)), ((System.Byte)(153)));
			this.gradientLabel3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.gradientLabel3.ForeColor = System.Drawing.Color.White;
			this.gradientLabel3.Location = new System.Drawing.Point(286, 220);
			this.gradientLabel3.Name = "gradientLabel3";
			this.gradientLabel3.Size = new System.Drawing.Size(434, 20);
			this.gradientLabel3.StartColor = System.Drawing.Color.FromArgb(((System.Byte)(102)), ((System.Byte)(153)), ((System.Byte)(204)));
			this.gradientLabel3.TabIndex = 22;
			this.gradientLabel3.Text = "Preview";
			// 
			// ImportOPML
			// 
			this.AcceptButton = this.OK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.Cancel;
			this.ClientSize = new System.Drawing.Size(730, 538);
			this.Controls.Add(this.gradientLabel3);
			this.Controls.Add(this.feedListView1);
			this.Controls.Add(this.All);
			this.Controls.Add(this.None);
			this.Controls.Add(this.gradientLabel2);
			this.Controls.Add(this.propertyGrid1);
			this.Controls.Add(this.gradientLabel1);
			this.Controls.Add(this.tvwSubscriptions);
			this.Controls.Add(this.Cancel);
			this.Controls.Add(this.OK);
			this.Controls.Add(this.lblDescription);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Name = "ImportOPML";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Import subscriptions from another program";
			this.Load += new System.EventHandler(this.ImportOPML_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		#region Private variables 

		private OPMLFile	master;
		private OPMLFile	import;
		private bool		inCheckEvent = false;

		#endregion 

		#region Static methods 

		public static OPMLFile ImportOPMLFile( OPMLFile master, string filename )
		{

			try
			{

				OpenFileDialog ofd = new OpenFileDialog();
				ofd.Title = "Import Subscriptions";
				ofd.AddExtension = true;
				ofd.CheckFileExists = true;
				ofd.CheckPathExists = true;
				ofd.DefaultExt = "opml";
				ofd.DereferenceLinks = true;
				ofd.Filter = "RSS Subscription Files (OPML)|*.opml|Xml Files|*.xml|All Files|*.*";
				if( ofd.ShowDialog() != DialogResult.OK )
					return null;
			
				if( ofd.FileName == "" || !File.Exists( ofd.FileName ) )
					return null;

				OPMLFile import = new OPMLFile( ofd.FileName );
				EliminateDuplicates( master, import );

				ImportOPML dlg = new ImportOPML();
				dlg.master = master;
				dlg.import = import;

				DialogResult result = dlg.ShowDialog();
				if( result != DialogResult.OK )
					return null;

				if( dlg.import.Nodes.Count == 0 )
					return null;

				return dlg.import;

			}
			catch( Exception err )
			{
				MessageBox.Show( "There was an error importing the subscriptions: " + err.Message, "RSS Reader" );
				return null;
			}

		}

		private static void EliminateDuplicates( OPMLFile master, OPMLFile import )
		{

			EliminateDuplicates( master, import.Nodes.Clone() );

		}

		private static void EliminateDuplicates( OPMLFile master, OPMLNodeCollection nodes )
		{

			foreach( OPMLNode node in nodes )
			{

				if( node is OPMLCategoryNode )
				{
					EliminateDuplicates( master, ((OPMLCategoryNode) node).Nodes.Clone() );
				}
				else if( node is OPMLItemNode )
				{

					if( master.IsSubscribed( ((OPMLItemNode) node).XmlUrl ) )
						node.Delete();

				}

			}

		}

		#endregion 

		public void RefreshTree()
		{

			try
			{

				tvwSubscriptions.BeginUpdate();

				PersistedTreeState state = new PersistedTreeState( tvwSubscriptions );

				tvwSubscriptions.Nodes.Clear();

				if( import == null )
					return;

				foreach( OPMLNode outline in import.Nodes )
				{
					AddSubscriptionNode( null, outline );
				}

				tvwSubscriptions.ExpandAll();
				
				if( tvwSubscriptions.Nodes.Count > 0 )
				{
					tvwSubscriptions.SelectedNode = tvwSubscriptions.Nodes[0];
					tvwSubscriptions.Nodes[0].EnsureVisible();
				}

				state.Restore();

			}
			finally
			{
				tvwSubscriptions.EndUpdate();
			}

		}

		private TreeNode AddSubscriptionNode( TreeNode Parent, OPMLNode Subscription )
		{

			if( Subscription is OPMLCategoryNode )
				if( ((OPMLCategoryNode) Subscription).Nodes.Count == 0 )
					return null;

			TreeNode node = new TreeNode( Subscription.Title );
			node.Tag = Subscription;

			if( Parent != null )
				Parent.Nodes.Add( node );
			else
				tvwSubscriptions.Nodes.Add( node );

			if( Subscription is OPMLCategoryNode )
			{

				node.ImageIndex = 11;
				node.SelectedImageIndex = 11;

				foreach( OPMLNode child in ((OPMLCategoryNode) Subscription).Nodes )
					AddSubscriptionNode( node, child );

			}
			else
			{

				node.ImageIndex = 2;
				node.SelectedImageIndex = 2;

			}

			return node;

		}

		private void CloseButton_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;
			this.Close();
		}

		private void RecurseCheckDown( TreeNode node )
		{

			foreach( TreeNode child in node.Nodes )
			{
				child.Checked = node.Checked;
				RecurseCheckDown( child );
			}

		}

		private void RecurseCheckUp( TreeNode node )
		{

			bool isChecked = false;
			foreach( TreeNode child in node.Nodes )
			{
				if( child.Checked )
				{
					isChecked = true;
					break;
				}
			}

			node.Checked = isChecked;

			if( node.Parent != null )
				RecurseCheckUp( node.Parent );

		}

		private void tvwSubscriptions_AfterCheck(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{

			if( inCheckEvent )
				return;

			try
			{

				inCheckEvent = true;

				TreeNode node = e.Node;
				RecurseCheckDown( node );
				if( node.Parent != null )
					RecurseCheckUp( node.Parent );

			}
			finally
			{
				inCheckEvent = false;
			}

		}

		private void ImportOPML_Load(object sender, System.EventArgs e)
		{
			RefreshTree();
		}

		private void tvwSubscriptions_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			this.propertyGrid1.SelectedObject = e.Node.Tag;
		}

		private void SetCheckedAll( bool isChecked, TreeNodeCollection nodes )
		{

			foreach( TreeNode node in nodes )
			{
				node.Checked = isChecked;
				SetCheckedAll( isChecked, node.Nodes );
			}

		}

		private void All_Click(object sender, System.EventArgs e)
		{
			SetCheckedAll( true, tvwSubscriptions.Nodes );
		}

		private void None_Click(object sender, System.EventArgs e)
		{
			SetCheckedAll( false, tvwSubscriptions.Nodes );
		}

		private void OK_Click(object sender, System.EventArgs e)
		{
			RemoveUncheckedNodes( tvwSubscriptions.Nodes );
		}

		private void RemoveUncheckedNodes( TreeNodeCollection nodes )
		{

			foreach( TreeNode node in nodes )
			{

				RemoveUncheckedNodes( node.Nodes );

				if( !node.Checked )
					((OPMLNode) node.Tag).Delete();

			}

		}

		private void tvwSubscriptions_DoubleClick(object sender, System.EventArgs e)
		{

			try
			{

				this.Cursor = Cursors.WaitCursor;

				this.feedListView1.Clear();

				TreeNode selected = this.tvwSubscriptions.SelectedNode;
				if( selected == null || !(selected.Tag is OPMLItemNode) )
					return;

				RSSFeed feed = FeedManager.RetrieveFeed( ((OPMLItemNode) selected.Tag).XmlUrl );
				if( feed == null )
					MessageBox.Show( "Failed to retrieve feed data", "RSS Reader" );
				else
					this.feedListView1.RefreshFeed( feed );

			}
			catch( Exception err )
			{
				MessageBox.Show( "Error retrieving feed data: " + err.Message, "RSS Reader" );
			}
			finally
			{
				this.Cursor = Cursors.Default;
			}
		
		}

	}

}